// catppuccin mocha
pub const background = fromBytes(.{ 0x18, 0x18, 0x25, 0xb0 });
pub const square_background = fromBytes(.{ 0x1e, 0x1e, 0x2e, 0xff });
pub const square_frame = fromBytes(.{ 0xf3, 0x8b, 0xa8, 0xff });
pub const bar_bg = fromBytes(.{ 0x11, 0x11, 0x1b, 0xff });
pub const clear_button = fromBytes(.{ 0x89, 0xb4, 0xfa, 0xff });

r: f32 = 0.0,
g: f32 = 0.0,
b: f32 = 0.0,
a: f32 = 1.0,

const Self = @This();

pub fn fromBytes(data: [4]u8) Self {
    return fromArray(
        @as(@Vector(4, f32), [_]f32{
            @floatFromInt(data[0]),
            @floatFromInt(data[1]),
            @floatFromInt(data[2]),
            @floatFromInt(data[3]),
        }) / @splat(4, @as(f32, 255.0)),
    );
}

pub fn fromArray(data: [4]f32) Self {
    return .{
        .r = data[0],
        .g = data[1],
        .b = data[2],
        .a = data[3],
    };
}

pub fn toArray(self: Self) [4]f32 {
    return .{
        self.r,
        self.g,
        self.b,
        self.a,
    };
}

pub fn mul(self: Self, other: Self) Self {
    return fromArray(
        @as(@Vector(4, f32), self.toArray()) *
            @as(@Vector(4, f32), other.toArray()),
    );
}
