const std = @import("std");
const gl = @import("gl.zig");
const zalgebra = @import("zalgebra");

pub const inital_win_size = zalgebra.Vec2_i32.new(800, 800);

// I'm not a fan of global state either, but this is really not possible to do
// otherwise becuase OpenGL also has global state.
pub var state: Self = undefined;

current_screen_size: zalgebra.Vec2_i32 = inital_win_size,

projection_matrix: zalgebra.Mat4 = undefined,

vbo: c_uint = 0,
vao: c_uint = 0,

shader_program: c_uint = 0,

font_vbo: c_uint = 0,
font_vao: c_uint = 0,

font_shader_program: c_uint = 0,

const Self = @This();

pub fn init() !void {
    state = .{};
}

pub fn deinit() void {
    state = undefined;
}

pub fn updateProjectionMatrix(size: zalgebra.Vec2_i32) void {
    state.projection_matrix = zalgebra.Mat4.orthographic(
        0.0,
        @floatFromInt(size.x()),
        0.0,
        @floatFromInt(size.y()),
        -1.0,
        1.0,
    );

    for ([_]c_uint{ state.shader_program, state.font_shader_program }) |program| {
        gl.useProgram(program);
        gl.uniformMatrix4fv(
            gl.getUniformLocation(program, "projection"),
            1,
            gl.FALSE,
            @ptrCast(&state.projection_matrix.data),
        );
    }
}
